//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------

if (!window.requestAnimationFrame)
{
  window.requestAnimationFrame = ( function() {
    return window.webkitRequestAnimationFrame ||
      window.mozRequestAnimationFrame ||
      window.oRequestAnimationFrame ||
      window.msRequestAnimationFrame ||
      function( /* function FrameRequestCallback */ callback, /* DOMElement Element */ element ) {
        window.setTimeout( callback, 1000 / 60 );
      };
  })();
}

var activeItem = 1;
var timerID    = 1;
var myScroll   = null;

var mainGames = gamesInit(xpromoGames);
var flag = false;
if(mainGames.length < 5)
  flag = true;
mainGames = mainGames.filter(function(element, index, array)
{
  var GRID = 10989;
  // filter out duplicates
  for (i = 0; i < index; i++)
    if (array[i].id == element.id)
      return false;

  // create store link
  if (!element.links)
    return false;

  /*if ("temp" in element.links)
    element.href = element.links.temp;
  else
  {*/
    if("download" in element.links)
      element.href = element.links.download;
    else
    if ("free" in element.links)
      element.href = element.links.free;
    else
    if ("lite" in element.links)
      element.href = element.links.lite;
    else
    if ("full" in element.links)
      element.href = element.links.full;
    else
    if ("temp" in element.links)
      element.href = element.links.temp;
    else
      return false;

    if (new Date().getTime() < element.date.getTime())
    {
      if ("temp" in element.links && flag)
      {
      }
      else
      {
        return false;
      }
    }
  //}

  element.href = convertLink("@ext(" + element.href + ")", GRID);
  return true;
});
gamesDirective = 
{
  "li" : 
  {
    "game<-games" : 
    {
      "a@href"      : "game.href",
      ".name"       : "game.name_short",
      ".icon@style" : function(arg) {
        return iconStyleFor(arg.item.id, 3);
      },
      ".icon@src" : function(arg) {
        return arg.item.id + "/" + iconNameFor(arg.item.id)
      },
      ".icon@alt_img" : function(arg) {
        if(isIpadNew)
        {
          return arg.item.id;
        }
        return '';
      }
    }
  }
}

function mainRender(_banners)
{
  var data = {};
  var curDate = new Date();
  data.banners = _banners;
  var cntGames = 0;
  /*mainGames = mainGames.filter(function(element, index, array) {
    return (element.date <= curDate);
  });*/
  var gamesBox = $p(".games-box-hidden ul.pplr");
  mainGames = replaceSort(mainGames, false);
  data.games = mainGames.slice(0);
  //data.games = replaceSort(data.games, false);
  gamesBox.autoRender(data, gamesDirective);
  // fixup width
  gamesBox[0].style.width = getWidthUL(gamesBox[0].childElementCount);

  data.games = mainGames.slice(0);
  data.games = replaceSort(data.games, true);
  gamesBox = $p(".games-box-hidden ul.rcnt");
  gamesBox.autoRender(data, gamesDirective);
  // fixup width
  gamesBox[0].style.width = getWidthUL(gamesBox[0].childElementCount);

  data.games = mainGames.filter(function(element, index, array)
  {
    if(element.genre == 'st' || element.genre == 'both')
      return true;
    else
      return false;
  });
  gamesBox = $p(".games-box-hidden ul.st");
  gamesBox.autoRender(data, gamesDirective);
  // fixup width
  gamesBox[0].style.width = getWidthUL(gamesBox[0].childElementCount);
  if (gamesBox[0].childElementCount > 0)
  {
    cntGames += gamesBox[0].childElementCount;
    $('#strategy strong').append(' (' + gamesBox[0].childElementCount + ')');
  }

  data.games = mainGames.filter(function(element, index, array) 
  {
    if(element.genre == 'adv' || element.genre == 'both')
      return true;
    else
      return false;
  });
  gamesBox = $p(".games-box-hidden ul.adv");
  gamesBox.autoRender(data, gamesDirective);
  // fixup width
  gamesBox[0].style.width = getWidthUL(gamesBox[0].childElementCount);
  if (gamesBox[0].childElementCount > 0)
  {
    cntGames += gamesBox[0].childElementCount;
    $('#adventure strong').append(' (' + gamesBox[0].childElementCount + ')');
  }

  if (cntGames > 0)
    $('#popular strong, #recent strong').append(' (' + cntGames + ')');

  gamesBox = $p(".games-box ul");
  gamesBox[0].innerHTML = $p(".games-box-hidden ul")[0].innerHTML;
  gamesBox[0].style.width = getWidthUL(gamesBox[0].childElementCount);
  // Set slyde animation
  if(!myScroll)
  {
    var gamesBoxUl = $('.games-box ul');
    var gameBox    = $('.games-box');
    var start      = (gamesBoxUl.width() - gameBox.width());
    if (start > 0)
    {
      $(".games-box ul").css({
        'transform' : 'translate3d(-' + start + 'px, 0px, 0px)',
        '-webkit-transform' : 'translate3d(-' + start + 'px, 0px, 0px)',
        'transition' : 'transform 0s linear',
        '-webkit-transition' : '-webkit-transform 0s linear'
      });
    }
  }
  // fixup width
  gamesBox[0].style.width = getWidthUL(gamesBox[0].childElementCount);
  var game = gamesLoadGame(xpromoGames, gamesSelfId());
  $p(".game-current").autoRender(game,
  {
    ".name"       : "name",
    ".icon@style" : function(arg) {
      var variant = '-big';
      if(isIpadNew && getPlatformFromId(game.id) == 'ipad')
        variant += '@2x';
      return "background-image: url(" + game.id + "/" + iconNameFor(game.id, variant) + ")" + iconStyleFor(game.id, 6);
    }
  });
}

function bannersRender(_data)
{
  $p(".banners-box").autoRender(_data, {
      ".banner-item" : 
      {
        "banner<-banners" : 
        {
          "@id"         : function(arg) { return "banner-item-" + (arg.pos + 1); },
          "@href"       : "banner.href",
          "@style"      : function(arg) 
          { 
            var result = "";

            if (arg.pos != 0)
              result += "display:none;";
  
            if (arg.item.style)
              result += arg.item.style;

            return result;
          },
          ".icon@style" : function(arg) 
          {
            if (arg.item.icon)
              return "background-image: url('" + XPROMO_SITE + arg.item.icon + "')";
        
            return "display:none;";
          },
          ".icon@alt_img" : function(arg) {
            if (arg.item.icon && isIpadNew){
              var tmp = arg.item.icon;
              var pos = tmp.indexOf('/');
              if(pos != -1)
              return tmp.substring(0, pos);
            }
            return '';
          },
          ".icon@class" : function(arg)
          {
            if (arg.item.icon)
            {
              var game_id = arg.item.icon;
              game_id = game_id.split('/');
              game_id = game_id[0];
              var platform = getPlatformFromId(game_id);
              return "icon icon_" + platform;
            }
            return "icon";
          },
          "div.text"    : "banner.text",
          ".+"          : function(arg) { return arg.item.button ? ("<div class='button'><span>" + arg.item.button + "</span></div>") : ""; }
        }
      }
    });
  if(isIpadNew)
    preloadBigImage();
}

function mainModal(_url)
{
  window.open(_url, "_blank", "width=800px, height=600px");
}

$(document).ready(function()
{
  setTimeout(function () { timerID = scrollerByTimeOut(); }, 7000);
  
  updateLayout();

  var userAgent = navigator.userAgent.toLowerCase();
  var hasScroll = false;

  hasScroll |= (userAgent.indexOf("ipad") != -1 || userAgent.indexOf("iphone") != -1) && 
               (userAgent.indexOf("os 3") == -1 && userAgent.indexOf("os 4")   == -1);

  hasScroll |= (userAgent.indexOf("trident") != -1);

  if (!hasScroll)
    myScroll = new iScroll($p(".games-box")[0], { vScroll : false });
});

$(window).resize(updateLayout);

function updateLayout()
{
  var userAgent = navigator.userAgent.toLowerCase();
  var zoom = (window.innerHeight / 768) * 100;

  document.body.style.zoom = zoom + "%";

  if (userAgent.indexOf("trident") != -1)
  {
    if (zoom>101 && zoom<101.5)
    {
      zoom = Math.round(zoom) - 1;
    }
    else
    if (zoom<100 && zoom>99.5)
    {
      zoom = Math.round(zoom) - 1;
    }

    if (zoom < Math.round(zoom))
      zoom = zoom + 1;

    zoom = Math.round(zoom);
    document.body.style.zoom = "";
    document.body.style.backgroundColor = "#31496c";
    $p(".main")[0].style.zoom = zoom + "%";
    $p(".main")[0].style.width = 100 * 100 / zoom + "%";
    $p(".banners-box")[0].style.borderTopStyle = "none";

    //document.body.style.width = 100 * 100 / zoom + "%";

    // MSIE bug? elements with position:absolute do not inherit zoom
    $p(".page-header a.logo")[0].style.zoom = document.body.style.zoom;
  }
  else
  if (userAgent.indexOf("android 4") == -1)
    document.body.style["font-size"] = document.body.style.zoom;

  var gamesBox = $p(".games-box ul");
  gamesBox[0].style.width = getWidthUL(gamesBox[0].childElementCount);
  
  if (myScroll)
    myScroll.refresh();
}

function clickEvent(event, target)
{
}

function scrollerByTimeOut() 
{
  var nextItem = (activeItem >= $('.banner-item').length) ? 1 : activeItem + 1;
  scroller(nextItem);
}

function scroller(aId) 
{
  if (activeItem != aId) 
  {
    $('#banner-item-' + activeItem).fadeOut(700);
    $('#banner-item-' + aId).fadeIn(700);
    activeItem = aId;
  }

  clearTimeout(timerID);
  timerID = setTimeout(function () 
  {
    scrollerByTimeOut()
  }, 7000);
}

//
// banners fetch
//

var XPROMO_SITE = "http://xpromo.g5e.com/v1/";
var BANNER_SITE = XPROMO_SITE + "news/";

with (window.localStorage)
{
  var bannerBase = getItem("xpromo.news.base");
  if (bannerBase)
    BANNER_SITE = XPROMO_SITE + bannerBase;
}

function bannersFetch(_onload)
{
  with (new XMLHttpRequest())
  {
    open("GET", BANNER_SITE + "banners.txt", true);
    onreadystatechange = function()
    {
      if (readyState != 4)
        return;

      var text;
      if (status == 200 ||
          responseText) // for local GET to work
      {
        text = responseText;
        window.localStorage.setItem("xpromo.banners", text);
      }
      else
      {
        text = window.localStorage.getItem("xpromo.banners");
      }

      if (text)
      {
        var xpromoBanners = lockitGet(JSON.parse(text));
        _onload(xpromoBanners);
      }
      else
        _onload(null);
    }
    send(null);
  }
}

// Generates a regular expression from the given wildcard string.
// http://jpaq.org/documentation/1.0/RegExp.fromWildExp()
RegExp.fromWildExp = function(pat, opts)
{
  var oOpt = opts && opts.indexOf("o") > -1;
  var i, m, p = "", sAdd = (opts && opts.indexOf("l") > -1 ? "" : "?");
  var re = new RegExp("~.|\\[!|" + (oOpt ? "{\\d+,?\\d*\\}|[" : "[")
    + (opts && opts.indexOf("p") > -1 ? "" : "\\(\\)")
    + "\\{\\}\\\\\\.\\*\\+\\?\\:\\^\\$%_#<>]");
  while ((i = pat.search(re)) > -1 && i < pat.length)
  {
    p += pat.substring(0, i);
    if((m = pat.match(re)[0]) == "[!")
      p += "[^";
    else if(m.charAt(0) == "~")
      p += "\\" + m.charAt(1);
    else if(m == "*" || m == "%")
      p += ".*" + sAdd;
    else if(m == "?" || m == "_")
      p += ".";
    else if(m == "#")
      p += "\\d";
    else if(oOpt && m.charAt(0) == "{")
      p += m + sAdd;
    else if(m == "<")
      p += "\\b(?=\\w)";
    else if(m == ">")
      p += "(?:\\b$|(?=\\W)\\b)";
    else
      p += "\\" + m;
    pat = pat.substring(i + m.length);
  }
  p += pat;
  if (opts)
  {
    if(/[ab]/.test(opts))
      p = "^" + p;
    if(/[ae]/.test(opts))
      p += "$";
  }
  return new RegExp(p, opts ? opts.replace(/[^gim]/g, "") : "");
}

// download data
function bannersInit()
{
  bannersFetch(function(xpromoBanners)
  {
    $(document).ready(function()
    {
      var GRID = 10989;
      var data = {};
      data.banners = lockitThis.banners;
      if (xpromoBanners)
        data.banners = xpromoBanners.banners.concat(data.banners);

      var timeNow = new Date().getTime();

      data.banners = data.banners.filter(function(element, index, array)
      {
        if (element.begsAt)
        {
          var begsAt = new Date(element.begsAt);
          if (timeNow < begsAt.getTime())
            return false;
        }
          
        if (element.endsAt)
        {
          var endsAt = new Date(element.endsAt);
          if (timeNow >= endsAt.getTime())
            return false;
        }

        var self_id = gamesSelfId();
        if (element.includes)
        {
          var arrIncludes = element.includes.split('|');
          if(!inArray(self_id, arrIncludes))
            return false;
        }

        if (element.excludes)
        {
          var arrExcludes = element.excludes.split('|');
          if(inArray(self_id, arrExcludes) != false)
            return false;
        }

        element.href = convertLink(element.href, GRID);
        return true;
      });
      bannersRender(data);
    });
  });
}

function scrollGame() {
  if (myScroll)
  {
    if (myScroll.maxScrollX < 0)
    {
      myScroll.scrollTo(myScroll.maxScrollX, 0, 0);
      setTimeout(function(){
        //myScroll.scrollTo(0, 0, Math.round(Math.abs(myScroll.maxScrollX) / 144 * 250));
        myScroll.scrollTo(0, 0, 4000);
      }, 1000);
    }
  }
  else
  {
    // CSS3 Animation
    setTimeout(function () {
      $(".games-box ul").css({
        'transform': 'translate3d(0px, 0px, 0px)',
        '-webkit-transform': 'translate3d(0px, 0px, 0px)',
        'transition': 'transform 4s linear',
        '-webkit-transition': '-webkit-transform 4s linear'
      });
      setTimeout(function () {
        var gamesBox = $p(".games-box ul");
        var donor = $p(".games-box-hidden ul.pplr");
        gamesBox[0].innerHTML  = donor[0].innerHTML;
        gamesBox[0].style.width = getWidthUL(donor[0].childElementCount);
      }, 4000)
    }, 1000);
  }
}

function changeType(a, tp) {
  var th = $(a);
  $('.select-type a').removeClass('selected');
  th.addClass('selected');
  var gamesBox = $p(".games-box ul");
  var donor = $p(".games-box-hidden ul." + tp);
  gamesBox[0].innerHTML  = donor[0].innerHTML;
  gamesBox[0].style.width = getWidthUL(donor[0].childElementCount);
  //gamesBox[0].style.webkitTransform = 'translate3d(-0px, 0px, 0px) scale(1)';
  if (myScroll)
  {
    myScroll.refresh();
    myScroll.scrollTo(0, 0, 0);
  }
  else
  {
    $(".games-box").scrollLeft('0');
  }
}

function getWidthUL(cnt) {
  var zoom = window.innerHeight / 768;
  var ret = Math.max(144 * cnt, window.innerWidth / zoom - 30);
  return ret + 'px';
}

function preloadBigImage() {
  var arr_load = new Array();
  var tmp;
  $('div.latest-games .icon').each(function(){
    tmp = $(this).attr('alt_img');
    if(getPlatformFromId(tmp) == 'ipad')
    {
      if(!inArray(tmp, arr_load))
        arr_load.push(tmp);
    }
  });
  if(arr_load.length > 0){
    var img = document.createElement('img');
    $(img).bind('load', function() {
      $('div.icon[alt_img="' + arr_load[0] + '"]').css('background-image', 'url(' + XPROMO_SITE + arr_load[0] + '/icon-big.jpg)').removeAttr('alt_img');
      $('img.icon[alt_img="' + arr_load[0] + '"]').attr('src', XPROMO_SITE + arr_load[0] + '/icon-big.jpg').removeAttr('alt_img');
      arr_load.shift();
      if(arr_load[0])
        img.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg';
    });
    img.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg';
  }
}

// Fire on load
window.addEventListener("load", function() {setTimeout(bannersInit, 100); requestAnimationFrame(scrollGame);}, false);