////-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: news.js
//  Description: 
//       Author: Davidovich V. (ringo@g5software.com)

var XPROMO_SITE = "http://xpromo.g5e.com/v1/";
var NEWS_ONE_HEIGHT = 70;
var NEWS_SITE  = XPROMO_SITE + "news/";
var NEWS_PAGE_SHOW = 1;
var NEWS_MAX_SHOWN = 0;

with (window.localStorage)
{
  if (!getItem("xpromo.news.read"))
    setItem("xpromo.news.read", "");
  var newsBase = getItem("xpromo.news.base");
  if (newsBase)
    NEWS_SITE = XPROMO_SITE + newsBase;
}
var newsDirective =
{
  "li.load" :
  {
    "new<-news" :
    {
      "@id"     : "new.id",
      "@class"  : "new.kind",
      "a span"  : "new.name",
      "a@href"  : "new.href",
      "@onclick" : function(arg) {
        if (arg.item.kind == 'unrd')
          return 'newsRead(this)';
        return '';
      },
      "@style" : function(arg) {
        if (arg.item.kind != 'more')
          return 'display: none';
        return '';
      }
    }
  }
}
function newsInit() {
  var text;
  with (new XMLHttpRequest())
  {
    open("GET", NEWS_SITE + ".txt", true);
    onreadystatechange = function()
    {
      if (readyState != 4)
        return;
      if (status == 200 ||
        responseText) // for local GET to work
      {
        text = responseText.replace(/[\r\n]/g, '');
        window.localStorage.setItem("xpromo.news", text);
      }
      else
      {
        text = window.localStorage.getItem("xpromo.news");
      }
    }
  }
}
function newsRender() {
  setZoomed(0, 1);
  var newsArray = lockitLoadLangs(NEWS_SITE);
  if (newsArray)
  {
    window.localStorage.setItem("xpromo.news", JSON.stringify(newsArray));
  }
  else
  {
    if (window.localStorage.getItem("xpromo.news"))
      newsArray = JSON.parse(window.localStorage.getItem("xpromo.news"));
  }
  var tmp;
  if (newsArray)
  {
    var resultArray = new Array();
    var lang = lockitGetLang();
    var thisDate = new Date().getTime();
    var newsRead = window.localStorage.getItem("xpromo.news.read");
    if (!newsRead)
      newsRead = '';
    for (var id in newsArray)
    {
      tmp = {};
      tmp.id = id;
      if (newsArray[id].date)
      {
        if (newsArray[id].date != null)
          tmp.date = new Date(newsArray[id].date).getTime();
      }
      if (newsArray[id].date_end)
      {
        if (newsArray[id].date_end != null)
          tmp.date_end = new Date(newsArray[id].date_end).getTime();
      }
      if (newsArray[id].name)
      {
        tmp.name = newsLocalized(lang, newsArray[id].name);
      }
      else
      {
        continue;
      }
      if (newsArray[id].href)
      {
        tmp.href = newsLocalized(lang, newsArray[id].href);
        tmp.href = tmp.href.replace('_de.html', '');
        tmp.href = tmp.href.replace('_en.html', '');
        tmp.href = tmp.href.replace('_es.html', '');
        tmp.href = tmp.href.replace('_fr.html', '');
        tmp.href = tmp.href.replace('_it.html', '');
        tmp.href = tmp.href.replace('_ru.html', '');
        tmp.href = NEWS_SITE + 'newsr.html?f=' + tmp.href + '&lang=' + lang;
      }
      else
      {
        continue;
      }
      tmp.kind = 'unrd';
      if ((newsRead + ";").indexOf(tmp.id) != -1)
        tmp.kind = 'read';
      resultArray[resultArray.length] = tmp;
    }
    resultArray = resultArray.filter(function(element, index, array){
      if (element.date)
      {
        if (element.date > thisDate)
          return false;
      }
      if (element.date_end)
      {
        if (element.date_end <= thisDate)
          return false;
      }
      return true;
    });
    resultArray[resultArray.length] =
    {
      "name" : lockit["li.more a span"],
      "href" : "javascript:newsMore()",
      "kind" : "more"
    };
    resultArray.news = resultArray;
    $p("ul").autoRender(resultArray, newsDirective);
    newsRedraw();
    window.addEventListener('resize', newsRedraw, false);
  }
}

function newsLocalized(_lang, _stringObject)
{
  return (_lang in _stringObject) ? _stringObject[_lang] : _stringObject["en"];
}

function newsRead(a) {
  a.onclick   = null;
  a.className = "read";
  var newsRead = window.localStorage.getItem("xpromo.news.read");
  newsRead += a.id + ";";
  window.localStorage.setItem("xpromo.news.read", newsRead);
}

function newsMore() {
  NEWS_PAGE_SHOW++;
  newsRedraw();
}

function newsRedraw() {
  var li = document.querySelectorAll('li');
  var zoom = document.body.style.zoom;
  if (zoom)
  {
    if (zoom.indexOf('%') != -1)
    {
      zoom = zoom.replace('%', '');
      zoom = zoom.replace('%', '');
      zoom = parseInt(zoom) / 100;
      if (zoom == 0)
        zoom = 1;
    }
  }
  else
  {
    zoom = 1;
  }
  NEWS_ONE_HEIGHT = Math.max(li[li.length - 1].clientHeight, li[0].clientHeight) * zoom;
  var tmp = Math.floor(window.innerHeight / NEWS_ONE_HEIGHT * NEWS_PAGE_SHOW) - 1;
  var flag = false;
  if (li.length <= (tmp + 1))
  {
    flag = true;
    tmp++;
  }
  if (tmp < 0)
    tmp = 0;
  if (tmp > NEWS_MAX_SHOWN)
  {
    for (var i = 0; i < li.length; i++)
    {
      if (i < tmp)
      {
        li[i].style.display = 'block';
      }
      else
      {
        break;
      }
    }
    NEWS_MAX_SHOWN = tmp;
  }
  if (flag)
    $p("li.more")[0].style.display = "none";
}