//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: taf.js
//  Description:
//       Author: Voronoy S. (sergey.voronoy@g5e.com)
function taf(_id, _link) {
  var defaultLink = 'http://www.g5e.com/';
  _link = typeof _link !== 'undefined' ? _link : defaultLink;
  var needLang = window.localStorage.getItem("xpromo.lang");
  var artistLink = window.localStorage.getItem("xpromo.artist.link");
  if (!checkVar(artistLink))
    artistLink = defaultLink;
  var userAgent = navigator.userAgent.toLowerCase();
  var flag_html = false;
  if (/(iphone|ipod|ipad)/i.test(userAgent) || userAgent.indexOf('trident') > -1)
    flag_html = true;
  var scripts = document.getElementsByTagName('script');
  var i = 0;
  var b;
  for(b in scripts)
  {
    if (!(scripts[b].src == undefined || scripts[b].src.toLowerCase().indexOf('lockit.js') == -1))
    {
      i = b;
      break;
    }
  }
  var path = scripts[i].src.split('?')[0];
  var mydir = path.split('/').slice(0, -2).join('/')+'/';

  var xmlhttp = new XMLHttpRequest();
  var txt;
  xmlhttp.open("GET", mydir + "taf.html", false);
  xmlhttp.send(null);
  txt = xmlhttp.responseText;

  var arrayTranslate, myReHTML, myReLang, myReTitle, myRePre, myReBody, htmlArr, tmp;
  arrayTranslate = {};
  myReHTML = /<html(\s|\S)*?<\/html>/igm;
  myReLang = /<html(?:\s)*?lang=(?:'|")(\w+)(?:'|")>/ig;
  myReTitle = /<title>(.*?)<\/title>/ig;
  myRePre = /<pre>((?:\s|\S)*)<\/pre>/igm;
  myReBody = /<body((?:\s|\S)*)<\/body>/igm;
  htmlArr = txt.match(myReHTML);
  for (b in htmlArr)
  {
    tmp = myReLang.exec(htmlArr[b]);
    if (tmp != null)
      arrayTranslate[tmp[1]] = htmlArr[b].replace(myReLang, '<html>');
    myReLang.exec('');
  }
  var retMessage = arrayTranslate[needLang];
  if (retMessage == undefined)
    retMessage = arrayTranslate['en'];
  tmp = myReTitle.exec(retMessage);
  var myTitle = tmp[1];
  if (flag_html)
  {
    tmp = myReBody.exec(retMessage);
    retMessage = tmp[0];
  }
  else
  {
    tmp = myRePre.exec(retMessage);
    retMessage = tmp[1];
  }
  retMessage = retMessage.replace(/{games_id}/g, _id);
  retMessage = retMessage.replace(/{artist_link}/g, artistLink);
  retMessage = (checkVar(_link)) ? retMessage.replace(/{store_link}/g, _link) : retMessage.replace(/{store_link}/g, artistLink);
  var text = lockitLoadLangs(_id + '/index');
  if (text == null)
  {
    return false;
  }
  else
  {
    text = lockitGet(text);
  }
  if (!text)
    text = [];
  var result = '';
  if (checkVar(text['title']))
  {
    text['title'] = text['title'].replace(/&apos;/gi, '\'');
    retMessage = retMessage.replace(/{game_name}/g, text['title']);
    result += "subject=" + encodeURIComponent(text['title']);
  }
  else
  {
    retMessage = retMessage.replace(/{game_name}/g, '');
  }
  if (checkVar(text['article span']) && checkVar(myTitle))
  {
    text['article span'] = text['article span'].replace(/<ul>((?:\s|\S)*)<\/ul>/igm, '');
    if (flag_html)
    {
      text['article span'] = myTitle + '<br>' + text['article span'] + '<br><br>';
    }
    else
    {
      text['article span'] = text['article span'].replace(/(<br \/>)|(<br>)|(<br\/>)/igm, "\n");
      text['article span'] = text['article span'].replace("\n\n", "\n");
      text['article span'] = decodeAmp(text['article span']);
      text['article span'] =  "\n" + myTitle + "\n" + text['article span'] + "\n\n";
    }
    retMessage = retMessage.replace(/{game_desc}/g, text['article span']);
  }
  else
  {
    retMessage = retMessage.replace(/{game_desc}/g, '');
  }
  if (flag_html)
    retMessage = "<html><body>" + retMessage + "</body></html>";

  retMessage = encodeURIComponent(retMessage);

  if (result.length > 0)
    result += '&';
  result += "body=" + retMessage;
  result = 'mailto:?' + result;

  result = result.replace(",", "%2C"); // for old xpromo clients
  simulateClick("@ext(" + result + ")");
  return false;
}

function decodeAmp(str) {
  var div = document.createElement('div');
  div.innerHTML = str;
  return div.firstChild.nodeValue;
}