//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: xpromoCoverFlow.js
//  Description:
//       Author: Davidovich V. (ringo@g5software.com)


if (!window.requestAnimationFrame)
{
  window.requestAnimationFrame = ( function() {
    return window.webkitRequestAnimationFrame ||
      window.mozRequestAnimationFrame ||
      window.oRequestAnimationFrame ||
      window.msRequestAnimationFrame ||
      function( /* function FrameRequestCallback */ callback, /* DOMElement Element */ element ) {
        window.setTimeout( callback, 1000 / 60 );
      };
  })();
}

with (window.localStorage)
{
  if (getItem("xpromo") == null || getItem("xpromo") == "test")
  {
    clear();
    setItem("xpromo",                "test");
    //setItem("xpromo.news.base",      "");
    setItem("xpromo.id",             "com.g5e.xpromodemo");
    setItem("xpromo.games.self.id",  "com.g5e.xpromoapp");
    setItem("xpromo.games.count",  "40");
    setItem("xpromo.games.0.id",  "com.g5e.secretsociety.hd");
    setItem("xpromo.games.1.id",  "com.g5e.virtualcitysb.hd");
    setItem("xpromo.games.2.id",  "com.g5e.abyss.hd");
    setItem("xpromo.games.3.id",  "com.g5e.buildalot3.hd");
    setItem("xpromo.games.4.id",  "com.g5e.inbetweenland.hd");
    setItem("xpromo.games.5.id",  "com.g5e.nightmaresdeep.hd");
    setItem("xpromo.games.6.id",  "com.g5e.carnival.hd");
    setItem("xpromo.games.7.id",  "com.g5e.whisperoffear.hd");
    setItem("xpromo.games.8.id",  "com.g5e.doomsdayprepperspg.hd");
    setItem("xpromo.games.9.id",  "com.fgames.lsoul.hd");
    setItem("xpromo.games.10.id",  "com.g5e.letters2.hd");
    setItem("xpromo.games.11.id",  "com.g5e.crystalportal2.hd");
    setItem("xpromo.games.12.id",  "com.orchidgames.royaltrouble.hd");
    setItem("xpromo.games.13.id",  "com.g5e.specialenquiry.hd");
    setItem("xpromo.games.14.id",  "com.g5e.pilotbr1.hd");
    setItem("xpromo.games.15.id",  "com.g5e.spiritwalkers.hd");
    setItem("xpromo.games.16.id",  "com.g5e.islandcastaway.hd");
    setItem("xpromo.games.17.id",  "com.g5e.smm2.hd");
    setItem("xpromo.games.18.id",  "com.g5e.letters.hd");
    setItem("xpromo.games.19.id",  "com.g5e.treasures3.hd");
    setItem("xpromo.games.20.id",  "com.g5e.treasureseekers4.hd");
    setItem("xpromo.games.21.id",  "com.g5e.treasures1.hd");
    setItem("xpromo.games.22.id",  "com.realore.janeshotel2.hd");
    setItem("xpromo.games.23.id",  "com.g5e.virtualcity2.hd");
    setItem("xpromo.games.24.id",  "com.g5e.epiconboard.hd");
    setItem("xpromo.games.25.id",  "com.g5e.strix.hd");
    setItem("xpromo.games.26.id",  "com.g5e.mahjonga2.hd");
    setItem("xpromo.games.27.id",  "com.g5e.standofood3.hd");
    setItem("xpromo.games.28.id",  "com.g5e.jack.hd");
    setItem("xpromo.games.29.id",  "com.g5e.virtualcity.hd");
    setItem("xpromo.games.30.id",  "com.g5e.buildalot4.hd");
    setItem("xpromo.games.31.id",  "com.g5e.bigfoot.hd");
    setItem("xpromo.games.32.id",  "com.g5e.mahjonga1.hd");
    setItem("xpromo.games.33.id",  "com.g5e.magicianbook2.hd");
    setItem("xpromo.games.34.id",  "com.g5e.crossworlds.hd");
    setItem("xpromo.games.35.id",  "com.g5e.totemtribegold.hd");
    setItem("xpromo.games.36.id",  "com.jetdogs.sinistercity.hd");
    setItem("xpromo.games.37.id",  "com.g5e.crystalportal.hd");
    setItem("xpromo.games.38.id",  "com.g5e.ts2.hd");
    setItem("xpromo.games.39.id",  "com.g5e.redrumdd.hd");
    setItem("xpromo.recomend.count",  "4");
    setItem("xpromo.recomend.0.id",  "com.g5e.virtualcity.hd");
    setItem("xpromo.recomend.1.id",  "com.g5e.crossworlds.hd");
    setItem("xpromo.recomend.2.id",  "com.g5e.xpromoapp.hd");
    setItem("xpromo.recomend.3.id",  "com.g5e.virtualcitysb.hd");
  }
}

var GAMES_NEW_DATE = new Date((new Date().getTime()) - 1000 * 60 * 60 * 24 * 42);

for (id in xpromoGames)
{
  try
  {
    var game  = xpromoGames[id];

    game.id   = id;
    game.date = new Date(game.date);

    if (game.date > GAMES_NEW_DATE)
      game.kind = "new";

    if (!("doomed" in game))
      game.doomed = 0;
  }
  catch (e)
  {
    delete xpromoGames[id];
  }
}

var activeItem = 1;
var timerID    = 1;
var myScroll   = null;
var isIpadNew = isIpadNewFunc();

var mainGames = gamesInit(xpromoGames);
var flag = (mainGames.length < 5)? true : false;

var XPROMO_SITE = "http://xpromo.g5e.com/v1/";
//var XPROMO_SITE = "http://192.168.5.226/";
var BANNER_SITE = XPROMO_SITE + "news/";
var bannerBase = window.localStorage.getItem("xpromo.news.base");
if (bannerBase)
  BANNER_SITE = XPROMO_SITE + bannerBase;

mainGames = mainGames.filter(function(element, index, array)
{
  var GRID = 10989;
  // filter out duplicates
  for (i = 0; i < index; i++)
    if (array[i].id == element.id)
      return false;

  // create store link
  if (!element.links)
    return false;

  if("download" in element.links)
    element.href = element.links.download;
  else
  if ("free" in element.links)
    element.href = element.links.free;
  else
  if ("lite" in element.links)
    element.href = element.links.lite;
  else
  if ("full" in element.links)
    element.href = element.links.full;
  else
  if ("temp" in element.links)
    element.href = element.links.temp;
  else
    return false;

  if (new Date().getTime() < element.date.getTime())
  {
    if ("temp" in element.links && flag)
    {
    }
    else
    {
      return false;
    }
  }
  element.href = convertLink("@ext(" + element.href + ")", GRID);
  return true;
});

gamesDirective =
{
  "li" :
  {
    "game<-games" :
    {
      "a@href"      : "game.href",
      ".name"       : "game.name_short",
      ".icon@style" : function(arg) {
        return iconStyleFor(arg.item.id, 3);
      },
      ".icon@src" : function(arg) {
        return arg.item.id + "/" + iconNameFor(arg.item.id)
      },
      ".icon@alt_img" : function(arg) {
        if(isIpadNew)
        {
          return arg.item.id;
        }
        return '';
      }
    }
  }
};

CoverFlowDirective  =
{
  "a" : {
    "game<-games" :
    {
      "img@src"  : function(arg) {
        return XPROMO_SITE + arg.item.id + "/home_b.jpg";
      },
      "img@alt"  : function(arg) {
        return XPROMO_SITE + arg.item.id + "/home_b.jpg";
      },
      "img@onload"  : function(arg) {
        return "loadBanner(this, false)";
      },
      "img@onerror"  : function(arg) {
        return "loadBanner(this, true)";
      },
      "@href"  : function(arg) {
        var GRID = 10987;
        var ret = '';
        ret = convertLink('@ext(' + arg.item.links.free + ')', GRID);
        if (ret == '')
          ret = 'javascript:subscribeExec()';
        return ret;
      }
    }
  }
};
BannerDirective =
{
  ".banner-item" :
  {
    "banner<-banners" :
    {
      "@id"         : function(arg) { return "banner-item-" + (arg.pos + 1); },
      "@href"       : "banner.href",
      "@style"      : function(arg)
      {
        var result = "";

        if (arg.pos != 0)
          result += "display:none;";

        if (arg.item.style)
          result += arg.item.style;

        return result;
      },
      ".icon@style" : function(arg)
      {
        if (arg.item.icon)
          return "background-image: url('" + XPROMO_SITE + arg.item.icon + "')";

        return "display:none;";
      },
      ".icon@alt_img" : function(arg) {
        if (arg.item.icon && isIpadNew){
          var tmp = arg.item.icon;
          var pos = tmp.indexOf('/');
          if(pos != -1)
            return tmp.substring(0, pos);
        }
        return '';
      },
      ".icon@class" : function(arg)
      {
        if (arg.item.icon)
        {
          var game_id = arg.item.icon;
          game_id = game_id.split('/');
          game_id = game_id[0];
          var platform = getPlatformFromId(game_id);
          return "icon icon_" + platform;
        }
        return "icon";
      },
      "div.text"    : "banner.text",
      ".+"          : function(arg) { return arg.item.button ? ("<div class='button'><span>" + arg.item.button + "</span></div>") : ""; }
    }
  }
};

function mainRender()
{
  var data = {};
  var gamesBox = $p(".games-box-hidden ul.pplr");
  mainGames = replaceSort(mainGames, false);
  data.games = mainGames.slice(0);
  gamesBox.autoRender(data, gamesDirective);
  // fixup width
  gamesBox[0].style.width = getWidthUL(gamesBox[0].childElementCount);
  if (gamesBox[0].childElementCount > 0)
    $("#popular strong").append(' (' + gamesBox[0].childElementCount + ')');

  data.games = mainGames.slice(0);
  data.games = replaceSort(data.games, true);
  gamesBox = $p(".games-box-hidden ul.rcnt");
  gamesBox.autoRender(data, gamesDirective);
  // fixup width
  gamesBox[0].style.width = getWidthUL(gamesBox[0].childElementCount);
  if (gamesBox[0].childElementCount > 0)
    $('#recent strong').append(' (' + gamesBox[0].childElementCount + ')');

  data.games = mainGames.filter(function(element, index, array)
  {
    if(element.genre == 'st' || element.genre == 'both')
      return true;
    else
      return false;
  });
  gamesBox = $p(".games-box-hidden ul.st");
  gamesBox.autoRender(data, gamesDirective);
  // fixup width
  gamesBox[0].style.width = getWidthUL(gamesBox[0].childElementCount);
  if (gamesBox[0].childElementCount > 0)
    $('#strategy strong').append(' (' + gamesBox[0].childElementCount + ')');

  data.games = mainGames.filter(function(element, index, array)
  {
    if(element.genre == 'adv' || element.genre == 'both')
      return true;
    else
      return false;
  });
  gamesBox = $p(".games-box-hidden ul.adv");
  gamesBox.autoRender(data, gamesDirective);
  // fixup width
  gamesBox[0].style.width = getWidthUL(gamesBox[0].childElementCount);
  if (gamesBox[0].childElementCount > 0)
    $('#adventure strong').append(' (' + gamesBox[0].childElementCount + ')');

  gamesBox = $p(".games-box ul");
  gamesBox[0].innerHTML = $p(".games-box-hidden ul")[1].innerHTML;
  gamesBox[0].style.width = getWidthUL(gamesBox[0].childElementCount);
}

function changeType(a, tp)
{
  var th = $(a);
  $('.select-type a').removeClass('selected');
  th.addClass('selected');
  var gamesBox = $p(".games-box ul");
  var donor = $p(".games-box-hidden ul." + tp);
  gamesBox[0].innerHTML  = donor[0].innerHTML;
  gamesBox[0].style.width = getWidthUL(donor[0].childElementCount);
  if (myScroll)
  {
    myScroll.refresh();
    myScroll.scrollTo(0, 0, 0);
  }
}

function getWidthUL(cnt)
{
  var zoom = window.innerHeight / 768;
  var ret = Math.max(144 * cnt, window.innerWidth / zoom - 30);
  return ret + 'px';
}

function updateLayout()
{
  var userAgent = navigator.userAgent.toLowerCase();
  var zoom = (window.innerHeight / 768) * 100;
  document.body.style.zoom = zoom + "%";

  if (userAgent.indexOf("trident") != -1)
  {
    zoom = Math.round(zoom) - 1;
    document.body.style.width = 100 * 100 / zoom + "%";
  }
  else
  if (userAgent.indexOf("android 4") == -1)
  {
    document.body.style["font-size"] = document.body.style.zoom;
  }

  var gamesBox = $p(".games-box ul");
  gamesBox[0].style.width = getWidthUL(gamesBox[0].childElementCount);

  if (myScroll)
    myScroll.refresh();
}

function scrollGame()
{
  if (myScroll)
  {
    if (myScroll.maxScrollX < 0)
    {
      myScroll.scrollTo(myScroll.maxScrollX, 0, 0);
      setTimeout(function(){
        myScroll.scrollTo(0, 0, 4000);
      }, 1000);
    }
  }
}

/*
* From Games.js
*
*/

function gamesInit(_table)
{
  var dataRecommended = {};
  var dataMore        = {};
  var dataNew         = {};

  var games = new Array(parseInt(window.localStorage.getItem("xpromo.games.count")));
  for (var i = 0; i < games.length; i++)
    games[i] = gamesLoadGame(_table,
      window.localStorage.getItem("xpromo.games." + i + ".id"));
  // filter unavailable games
  games = games.filter(function(element, index, array)
  {
    return element != null;
  });
  var preRecomended = new Array();
  preRecomended.id = new Array();
  var len = parseInt(window.localStorage.getItem("xpromo.recomend.count"));
  var tmp;
  for(var i = 0; i < len; i++)
  {
    tmp = window.localStorage.getItem("xpromo.recomend." + i + ".id");
    if(tmp != null)
      preRecomended.id[preRecomended.id.length] = tmp;
  }
  var self_id = window.localStorage.getItem("xpromo.games.self.id")||window.localStorage.getItem("xpromo.id");

  var genre = 'st';
  var game = gamesLoadGame(xpromoGames, self_id);
  if(game.genre != undefined)
  {
    if(game.genre == 'adv')
      genre = game.genre;
  }
  if(games.length > 4)
  {
    games = games.filter(function(element, index, array)
    {
      return element.id != self_id;
    });
  }
  preRecomended.games = games.filter(function(element, index, array)
  {
    return inArray(element.id, preRecomended.id);
  });
  var dataComing = {};
  var currentDate = new Date();
  dataComing.games = games;
  dataComing.games = dataComing.games.filter(function(element, index, array)
  {
    if(element.date > currentDate)
    {
      return true;
    }
    else if(element.links != undefined)
    {
      if(element.links.length > 0)
        return true;
    }
    return false;
  });
  //change kind of games
  for(var b in games)
  {
    if(dataComing.games.indexOf(games[b]) != -1)
      games[b].kind = 'coming';
  }
  for(var b in dataComing.games)
    dataComing.kind = 'coming';
  dataComing.games.sort(function(a, b)
  {
    b = (b.doomed == -1) ? new Date(0) : b.date;
    a = (a.doomed == -1) ? new Date(0) : a.date;

    return b - a;
  });
  dataNew.games = games.slice(0);
  dataNew.games = dataNew.games.filter(function(element, index, array)
  {
    return -1 == dataComing.games.indexOf(element);
  });
  dataNew.games.sort(function(a, b)
  {
    b = (b.doomed == -1) ? new Date(0) : b.date;
    a = (a.doomed == -1) ? new Date(0) : a.date;

    return b - a;
  });
  i = dataComing.games.length;
  i = parseInt(i);
  //dataNew.games = dataComing.games.concat(dataNew.games);
  dataNew.games = dataNew.games.slice(0, 4 - i);
  dataNew.games = dataNew.games.concat(dataComing.games);
  dataMore.games = games;
  dataMore.games = dataMore.games.filter(function(element, index, array)
  {
    return (-1 == dataNew.games.indexOf(element)) && (-1 == preRecomended.games.indexOf(element));
  });

  //dataMore.games = dataMore.games.slice(4);
  var gamesMyGenre = {};
  var gamesAnotherGenre = {};
  gamesMyGenre.games = dataMore.games.filter(function(element, index, array)
  {
    return element.genre == genre;
  });
  gamesAnotherGenre.games = dataMore.games.filter(function(element, index, array)
  {
    return -1 == gamesMyGenre.games.indexOf(element);
  });
  dataMore.games = gamesMyGenre.games.concat(gamesAnotherGenre.games);

  dataRecommended.games = preRecomended.games.concat(dataMore.games.slice(0, 4));
  dataRecommended.games = dataRecommended.games.slice(0, 4);
  dataRecommended.games.sort(function(a, b)
  {
    b = (b.doomed == -1) ? new Date(0) : b.date;
    a = (a.doomed == -1) ? new Date(0) : a.date;

    return b - a;
  });
  dataMore.games = dataMore.games.filter(function(element, index, array)
  {
    return -1 == dataRecommended.games.indexOf(element);
  });

  //dataNew.games.reverse();
  return games;
}

function gamesLoadGame(_table, _id)
{
  //TODO: check this code laters
  var lockit = lockitLoad(_id + "/index");
  if (!lockit)
  {
    console.log("not found: " + _id);
    return null;
  }
  var game = _table[_id];
  if (!game)
  {
    game = {};
    game.id = _id;
  }
  game.name       = lockit["title"];
  game.name_short = lockit["title_short"] || game.name;
  game.links      = lockit["#links"];
  game.genre      = lockit["genre"].toLowerCase();
  game.slogan     = lockit["#slogan"] || ""; //add for new GF
  if (!_table[_id])
    _table[_id] = game;
  return game;
}

function replaceSort(arr, flag)
{
  var arr_doomed, arr_middle, arr_top;
  arr_doomed = arr.filter(function(element, index, array)
  {
    return (element.doomed < 0);
  });
  if (flag)
  {
    arr_doomed.sort(function(a, b)
    {
      return b.date - a.date;
    });
  }
  if (flag)
  {
    arr_middle = arr.filter(function(element, index, array)
    {
      return (element.doomed == 0);
    });
    arr_middle.sort(function(a, b)
    {
      return b.date - a.date;
    });
    arr_top = arr.filter(function(element, index, array)
    {
      return (element.doomed > 0);
    });
    arr_top.sort(function(a, b)
    {
      return b.date - a.date;
    });
    var ret = new Array();
    var i;
    for (var b in arr_top)
    {
      i = arr_top[b].doomed - 1;
      while(ret[i] != undefined)
        i++;
      ret[i] = arr_top[b];
    }
    i = 0;
    for (var b in arr_middle)
    {
      while(ret[i] != undefined)
        i++;
      ret[i] = arr_middle[b];
    }
    for (var b in arr_doomed)
    {
      while(ret[i] != undefined)
        i++;
      ret[i] = arr_doomed[b];
    }
  }
  else
  {
    arr_middle = arr.filter(function(element, index, array)
    {
      return (element.doomed > -1);
    });
    var ret = arr_middle.concat(arr_doomed);
  }
  return ret;
}

/*
* banners fetch
*/
function bannersFetch(_onload)
{
  with (new XMLHttpRequest())
  {
    open("GET", BANNER_SITE + "banners.txt", true);
    onreadystatechange = function()
    {
      if (readyState != 4)
        return;

      var text;
      if (status == 200 ||
        responseText) // for local GET to work
      {
        text = responseText;
        window.localStorage.setItem("xpromo.banners", text);
      }
      else
      {
        text = window.localStorage.getItem("xpromo.banners");
      }

      if (text)
      {
        var xpromoBanners = lockitGet(JSON.parse(text));
        _onload(xpromoBanners);
      }
      else
        _onload(null);
    }
    send(null);
  }
}

// download data
function bannersInit()
{
  bannersFetch(function(xpromoBanners)
  {
    $(document).ready(function()
    {
      var GRID = 10989;
      var data = {};
      data.banners = lockitThis.banners;
      if (xpromoBanners)
        data.banners = xpromoBanners.banners.concat(data.banners);

      var timeNow = new Date().getTime();

      data.banners = data.banners.filter(function(element, index, array)
      {
        if (element.begsAt)
        {
          var begsAt = new Date(element.begsAt);
          if (timeNow < begsAt.getTime())
            return false;
        }

        if (element.endsAt)
        {
          var endsAt = new Date(element.endsAt);
          if (timeNow >= endsAt.getTime())
            return false;
        }

        var self_id = window.localStorage.getItem("xpromo.games.self.id")||window.localStorage.getItem("xpromo.id");
        if (element.includes)
        {
          var arrIncludes = element.includes.split('|');
          if(!inArray(self_id, arrIncludes))
            return false;
        }

        if (element.excludes)
        {
          var arrExcludes = element.excludes.split('|');
          if(inArray(self_id, arrExcludes) != false)
            return false;
        }

        element.href = convertLink(element.href, GRID);
        return true;
      });
      //bannersRender(data);
      $p(".banners-box").autoRender(data, BannerDirective);
      if(isIpadNew)
        preloadBigImage();
    });
  });
}

/*
*
* */
function preloadBigImage() {
  var arr_load = new Array();
  var tmp;
  $('div.latest-games .icon').each(function(){
    tmp = $(this).attr('alt_img');
    if(getPlatformFromId(tmp) == 'ipad')
    {
      if(!inArray(tmp, arr_load))
        arr_load.push(tmp);
    }
  });
  if(arr_load.length > 0){
    var img = document.createElement('img');
    $(img).bind('load', function() {
      $('div.icon[alt_img="' + arr_load[0] + '"]').css('background-image', 'url(' + XPROMO_SITE + arr_load[0] + '/icon-big.jpg)').removeAttr('alt_img');
      $('img.icon[alt_img="' + arr_load[0] + '"]').attr('src', XPROMO_SITE + arr_load[0] + '/icon-big.jpg').removeAttr('alt_img');
      arr_load.shift();
      if(arr_load[0])
        img.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg';
    });
    img.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg';
  }
}

/*
 *
 * */
function scrollerByTimeOut()
{
  var nextItem = (activeItem >= $('.banner-item').length) ? 1 : activeItem + 1;
  scroller(nextItem);
}

function scroller(aId)
{
  if (activeItem != aId)
  {
    $('#banner-item-' + activeItem).fadeOut(700);
    $('#banner-item-' + aId).fadeIn(700);
    activeItem = aId;
  }

  clearTimeout(timerID);
  timerID = setTimeout(function ()
  {
    scrollerByTimeOut()
  }, 7000);
}
